// NewXmlbackendProjDlg.cpp : implementation file
//

#include "stdafx.h"
#include "gme.h"
#include "NewXmlbackendProjDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CNewXmlbackendProjDlg dialog


CNewXmlbackendProjDlg::CNewXmlbackendProjDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CNewXmlbackendProjDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CNewXmlbackendProjDlg)
	m_location = _T("");
	m_projectName = _T("");
	m_vssDatabase = _T("");
	m_vssPath = _T("");
	m_sourceControlType = 0;
	//}}AFX_DATA_INIT
}


void CNewXmlbackendProjDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CNewXmlbackendProjDlg)
	DDX_Control(pDX, IDC_EDIT_VSSPATH, m_vssPathCtrl);
	DDX_Control(pDX, IDC_EDIT_VSSDATABASE, m_vssDatabaseCtrl);
	DDX_Control(pDX, IDC_BUTTON_BROWSE_VSSDB, m_vssBrowseButton);
	DDX_Control(pDX, IDC_STATIC_VSSPROJ, m_vssProjLabel);
	DDX_Control(pDX, IDC_STATIC_VSSDB, m_vssDbLabel);
	DDX_Control(pDX, IDC_STATIC_VSS, m_vssBorder);
	DDX_Text(pDX, IDC_EDIT_LOCATION, m_location);
	DDX_Text(pDX, IDC_EDIT_PROJNAME, m_projectName);
	DDX_Text(pDX, IDC_EDIT_VSSDATABASE, m_vssDatabase);
	DDX_Text(pDX, IDC_EDIT_VSSPATH, m_vssPath);
	DDX_Radio(pDX, IDC_RADIO_VSS, m_sourceControlType);
	//}}AFX_DATA_MAP
}

void CNewXmlbackendProjDlg::enableSourceSafeControls( bool enable )
{
    m_vssBorder.EnableWindow( enable );
    m_vssBrowseButton.EnableWindow( enable );
    m_vssProjLabel.EnableWindow( enable );
    m_vssDbLabel.EnableWindow( enable );
    m_vssDatabaseCtrl.EnableWindow( enable );
    m_vssPathCtrl.EnableWindow( enable );
}
    

BEGIN_MESSAGE_MAP(CNewXmlbackendProjDlg, CDialog)
	//{{AFX_MSG_MAP(CNewXmlbackendProjDlg)
	ON_BN_CLICKED(IDC_BUTTON_BROWSE_LOC, OnButtonBrowseLoc)
	ON_BN_CLICKED(IDC_BUTTON_BROWSE_VSSDB, OnButtonBrowseVssdb)
	ON_BN_CLICKED(IDC_RADIO_CLEARCASE, OnSourceControlChanged)
	ON_BN_CLICKED(IDC_RADIO_NONE, OnSourceControlChanged)
	ON_BN_CLICKED(IDC_RADIO_VSS, OnSourceControlChanged)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CNewXmlbackendProjDlg message handlers

void CNewXmlbackendProjDlg::OnButtonBrowseLoc() 
{
    BROWSEINFO bi;

    char szDisplayName[MAX_PATH];
    char szPath[MAX_PATH];

	bi.hwndOwner      = m_hWnd;
	bi.pidlRoot       = NULL;
	bi.lpszTitle      = "Select the project location.";
	bi.pszDisplayName = szDisplayName;
	bi.ulFlags        = BIF_RETURNONLYFSDIRS;
	bi.lpfn           = NULL;
	bi.lParam         = 0;

    LPITEMIDLIST idlist = SHBrowseForFolder(&bi);

    if( idlist && SHGetPathFromIDList(idlist, szPath) )
    {
        UpdateData();
        m_location = szPath;
        UpdateData(FALSE);
    }
}

void CNewXmlbackendProjDlg::OnButtonBrowseVssdb() 
{
    CFileDialog dlg(true, NULL, "srcsafe.ini", OFN_EXPLORER | OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, "SourceSafe Database (srcsafe.ini)|srcsafe.ini||" );

    if( dlg.DoModal() == IDOK )	
    {
        UpdateData();
        m_vssDatabase = dlg.GetPathName();
        UpdateData(FALSE);
    }
}

void CNewXmlbackendProjDlg::OnSourceControlChanged() 
{
    UpdateData();

    enableSourceSafeControls( m_sourceControlType == 0 );
}

void CNewXmlbackendProjDlg::OnOK()
{
    UpdateData();

    m_connectionString = "MGX=\"";
    m_connectionString += m_location;
    m_connectionString += "\\";
    m_connectionString += m_projectName;
    m_connectionString += "\"";

    if( m_sourceControlType == 0 )
    {
        if( !m_vssDatabase.IsEmpty() )
        {
            m_connectionString += " vssDatabase=\"";
            m_connectionString += m_vssDatabase;
            m_connectionString += "\" vssPath=\"";
            m_connectionString += m_vssPath;
            m_connectionString += "\"";
        }	
    }
    else if( m_sourceControlType == 1 )
    {
        m_connectionString += " clearCase=\"true\"";
    }
	
	CDialog::OnOK();
}

