from win32api import *
from win32gui import *
import win32con
import win32ui

import os
import pythoncom

RESOURCE_FILE = 'create.dll'
TEMPLATE_FILE = 'create.tpl'

IDD_DIALOG1 = 1000
IDD_DIALOG2 = 1001

IDC_EDITNAME = 1000
IDC_EDITDESCR = 1001
IDC_EDITICON = 1002
IDC_BUTTONICON = 1003
IDC_EDITPARADIGM = 1004

IDOK = 1
IDCANCEL = 2

IDC_REGISTER = 1007
IDC_PATH = 1008

PATH = os.getcwd()

class CreateDlg:
    def __init__(self):
        message_map = {
            win32con.WM_INITDIALOG: self.InitDialog,
            win32con.WM_COMMAND: self.OnCommand,
            win32con.WM_DESTROY: self.OnDestroy
        }
        self.res = LoadLibrary(RESOURCE_FILE)
        DialogBox(self.res, IDD_DIALOG1, 0, message_map)
        
    def InitDialog(self, hwnd, msg, wparam, lparam):
        return 1

    def OnCommand(self, hwnd, msg, wparam, lparam):
        if wparam == IDCANCEL or wparam == IDOK:
            if wparam == IDOK:
                ih = GetDlgItem(hwnd, IDC_EDITNAME)
                self.id = GetWindowText(ih)
                ih = GetDlgItem(hwnd, IDC_EDITDESCR)
                self.name =GetWindowText(ih)
                ih = GetDlgItem(hwnd, IDC_EDITPARADIGM)
                self.paradigm =GetWindowText(ih)
                ih = GetDlgItem(hwnd, IDC_EDITICON)
                self.icon =GetWindowText(ih)
                dlg = win32ui.CreateFileDialog(0, ".py", self.id + ".py", win32con.OFN_OVERWRITEPROMPT, "Python Files|*.py||")
                dlg.SetOFNTitle("Save Component As")
                res = dlg.DoModal()
                if res != win32con.IDCANCEL:
                    f = open(PATH + "\\" + TEMPLATE_FILE)
                    s = f.read()
                    guid = pythoncom.CreateGuid()
                    s = s.replace("<<GUID>>", str(guid))
                    s = s.replace("<<ID>>", self.id)
                    s = s.replace("<<NAME>>", self.name)
                    s = s.replace("<<PARADIGM>>", self.paradigm)
                    s = s.replace("<<ICON>>", self.icon)
                    f.close
                    import os.path
                    self.genScript = dlg.GetPathName()
                    self.genPath = os.path.split(self.genScript)[0]
                    f = open(self.genScript, 'w')
                    f.write(s)
                    f.close()
                    fdlg = FinishDlg(self)
            EndDialog(hwnd, 1)
        elif wparam == IDC_BUTTONICON:
            dlg = win32ui.CreateFileDialog(1, ".ico", "", win32con.OFN_FILEMUSTEXIST, "Icon files|*.ico||")
            dlg.SetOFNTitle("Icon Location")
            res = dlg.DoModal()
            if res <> win32con.IDCANCEL:
                SetDlgItemText(hwnd, IDC_EDITICON, dlg.GetPathName())
        return 1

    def OnDestroy(self, hwnd, msg, wparam, lparam):
        return 1

class FinishDlg:
    def __init__(self, createDlg):
        self.createDlg = createDlg
        message_map = {
            win32con.WM_INITDIALOG: self.InitDialog,
            win32con.WM_COMMAND: self.OnCommand,
            win32con.WM_DESTROY: self.OnDestroy
        }
        DialogBox(createDlg.res, IDD_DIALOG2, 0, message_map)
        
    def InitDialog(self, hwnd, msg, wparam, lparam):
        ih = GetDlgItem(hwnd, IDC_REGISTER)
        SendMessage(ih, win32con.BM_CLICK, 0, 0)
        ih = GetDlgItem(hwnd, IDC_PATH)
        SendMessage(ih, win32con.BM_CLICK, 0, 0)
        return 1

    def OnCommand(self, hwnd, msg, wparam, lparam):
        if wparam == IDOK:
            ih = GetDlgItem(hwnd, IDC_REGISTER)
            ret = SendMessage(ih, win32con.BM_GETCHECK, 0, 0)
            register = ret == win32con.BST_CHECKED
            ih = GetDlgItem(hwnd, IDC_PATH)
            ret = SendMessage(ih, win32con.BM_GETCHECK, 0, 0)
            setpath = ret == win32con.BST_CHECKED
            import sys
            if register:
                if self.createDlg.genPath not in sys.path:
                    sys.path.insert(0, self.createDlg.genPath)                
                interp = __import__(self.createDlg.id)
                sys.argv[0] = self.createDlg.genScript
                interp.Register()
            if setpath:
                PythonPath = ('SOFTWARE', 'Python', 'PythonCore', sys.winver, 'PythonPath')
                base=win32con.HKEY_LOCAL_MACHINE
                for k in PythonPath:
                    base = RegOpenKey(base,k,0,win32con.KEY_READ)
                hkey = RegCreateKey(base,self.createDlg.id)
                RegSetValueEx(hkey,"",None,win32con.REG_SZ,self.createDlg.genPath)                   
            EndDialog(hwnd, 1)
        return 1

    def OnDestroy(self, hwnd, msg, wparam, lparam):
        return 1

cdlg = CreateDlg()
