// FileTransDlg.cpp : implementation file
//

#include "stdafx.h"
#include "CMgaXslt.h"
#include "ModelMigrate.h"
#include "FileTransDlg.h"
#include "RuleEditorDlg.h"
#include "Validator.h"
#include "OptionsDlg.h"
#include "AboutDlg.h"

#include <afxwin.h>
#include ".\filetransdlg.h"

#define DEF_APPEND_STR                              "_out"
#define DEF_OUTPUTDIR_STR                           ""
/*static*/ CString FileTransDlg::m_strSection       = "Options";
/*static*/ CString FileTransDlg::m_strDirStringItem = "DefaultDir";
/*static*/ CString FileTransDlg::m_strScrStringItem = "DefaultScr";
/*static*/ CString FileTransDlg::m_strAppendStringItem          = "AppendedString";
/*static*/ CString FileTransDlg::m_strAppendStr                 = DEF_APPEND_STR;
/*static*/ CString FileTransDlg::m_strOutputDirStringItem       = "OutputDir";
/*static*/ CString FileTransDlg::m_strOutputDirStr              = DEF_OUTPUTDIR_STR;

// FileTransDlg dialog

IMPLEMENT_DYNAMIC(FileTransDlg, CDialog)
FileTransDlg::FileTransDlg(CWnd* pParent /*=NULL*/)
	: CDialog(FileTransDlg::IDD, pParent)
	, m_cx( 0)
	, m_cy( 0)
	, m_dlgRuleEditor( 0)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

FileTransDlg::~FileTransDlg()
{
	closeDlgRuleEditor(IDCANCEL);
	m_dlgRuleEditor = 0;
}

void FileTransDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LISTFILES, m_lstFiles);
	DDX_Control(pDX, IDC_EDIT4, m_log);
	DDX_Control(pDX, IDC_LISTSCRIPT, m_lstScript);
}


BEGIN_MESSAGE_MAP(FileTransDlg, CDialog)
	ON_WM_CREATE()
	ON_WM_SIZE()
	ON_WM_SIZING()
	ON_BN_CLICKED(IDC_BUTTON1, OnBnClickedRuleEditor)
	ON_BN_CLICKED(IDC_BUTTON2, OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnBnClickedButton3)
	ON_BN_CLICKED(IDC_BUTTON4, OnBnClickedButton4)
	ON_BN_CLICKED(IDC_BUTTON5, OnBnClickedButton5)
	ON_BN_CLICKED(IDC_BUTTON6, OnBnClickedButton6)
	ON_BN_CLICKED(IDC_BUTTONCLEAR, OnBnClickedButtonclear)
	ON_BN_CLICKED(IDC_BUTTON8, OnBnClickedButton8)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_NOTIFY(LVN_KEYDOWN, IDC_LISTSCRIPT, OnLvnKeydownListscript)
	ON_NOTIFY(LVN_KEYDOWN, IDC_LISTFILES, OnLvnKeydownListfiles)
END_MESSAGE_MAP()

// FileTransDlg message handlers

BOOL FileTransDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	//HACCEL hA = LoadAccelerators( 0, "IDR_MAINACCELERATOR");
	///BOOL res = TranslateAccelerator( GetSafeHwnd(), hA, 0);

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon


	m_lstFiles.m_parent = this;
	m_lstScript.m_parent = this;

	CWinApp* pApp = AfxGetApp();

	CString strV1, strV2, strV3, strV4 ;
	loadMyOptions( strV1, strV2, strV3, strV4);

	loadDir( strV1);
	CString conn( strV2);
	if( !strV2.IsEmpty())
	{
		int pos = conn.ReverseFind('\\');
				
		if( pos != -1)
			m_lstScript.addFile( conn.Right( conn.GetLength() - pos - 1), conn);
		else
			m_lstScript.addFile( conn, conn);
	}

	FileTransDlg::m_strAppendStr = strV3.IsEmpty()? DEF_APPEND_STR:strV3;
	FileTransDlg::m_strOutputDirStr = strV4;

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

int FileTransDlg::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;

	CRect rect;
	GetWindowRect( &rect);
	m_cy = rect.bottom;
	m_cx = rect.right;

	return 0;
}

void FileTransDlg::OnSizing(UINT fwSide, LPRECT pRect)
{
	const int desiredX = 300, desiredY = 300;
	if( pRect->bottom - pRect->top > desiredY
	 && pRect->right - pRect->left > desiredX)
		CDialog::OnSizing(fwSide, pRect);
	else
	{
		if( pRect->bottom - pRect->top < desiredY) pRect->bottom = pRect->top + desiredY;
		if( pRect->right - pRect->left < desiredX) pRect->right = pRect->left + desiredX;
	}
}

void FileTransDlg::OnSize(UINT nType, int cx, int cy)
{
	if( cx < 150) cx = 150; // these are not preventing the user to make the window to small
	if( cy < 150) cy = 150; // just prevent the controls to be shuffled when cx,cy are very close to 0

	CDialog::OnSize(nType, cx, cy);
	if( nType == SIZE_MINIMIZED) return;
	m_cx = cx;
	m_cy = cy;
	CRect rect, r1, r2;
	int sy = 0;
	if( cx && cy && m_lstFiles.GetSafeHwnd() && m_log.GetSafeHwnd()) // if minimized cx == cy == 0
	{
		m_lstFiles.GetWindowRect( &r1); ScreenToClient( &r1);
		m_log.GetWindowRect( &r2);   ScreenToClient( &r2);

		rect = r1;

		sy = (cy - r1.top)*3/5;

		rect.bottom = rect.top + sy;
		
		rect.right  = cx - rect.left; // maintain margin
		m_lstFiles.SetWindowPos( 0, 0, 0, rect.Width(), rect.Height(), SWP_NOMOVE|SWP_NOZORDER|SWP_SHOWWINDOW);

		rect.top = rect.bottom + r2.top - r1.bottom;
		rect.bottom = cy - 13;
		rect.right  = cx - rect.left; // maintain margin
		m_log.SetWindowPos( 0, rect.left, rect.top, rect.Width(), rect.Height(), SWP_NOZORDER|SWP_SHOWWINDOW);
	}
}

void FileTransDlg::OnBnClickedRuleEditor()
{
	ruleEditor();
}

void FileTransDlg::OnBnClickedButton2()
{
	selDir();
}


void FileTransDlg::OnBnClickedButton6()
{
	selFile();
}

void FileTransDlg::OnBnClickedButton3()
{
	CFileDialog dlg( TRUE, "xsl", 0, 0,
		"XSLT Files (*.xsl;*.xslt)|*.xsl; *.xslt|All Files (*.*)|*.*||");
	if( dlg.DoModal() == IDOK)
	{
		m_lstScript.addFile( dlg.GetFileName(), dlg.GetPathName());
	}
}

void FileTransDlg::OnBnClickedButton4()
{
	processAll();
}

void FileTransDlg::OnBnClickedButton8()
{
	processSel();
}

void FileTransDlg::OnBnClickedButton5()
{
	options();
}

void FileTransDlg::options()
{
	OptionsDlg dlg;
	// load the current values from registry
	loadMyOptions( dlg.m_dir, dlg.m_scr, dlg.m_append, dlg.m_outputDir);
	if( dlg.m_append.IsEmpty()) dlg.m_append = FileTransDlg::m_strAppendStr;

	if( dlg.DoModal() == IDOK)
	{
		// store the freshly modified options in static members
		FileTransDlg::m_strAppendStr = dlg.m_append;
		FileTransDlg::m_strOutputDirStr = dlg.m_outputDir;

		// save into registry
		saveMyOptions( dlg.m_dir, dlg.m_scr, dlg.m_append, dlg.m_outputDir);
	}
}

void FileTransDlg::ruleEditor()
{
	// stored by a member variable
	if( !m_dlgRuleEditor)
	{
		m_dlgRuleEditor = new RuleEditorDlg();
	}
	if( m_dlgRuleEditor->m_closed)
	{
		m_dlgRuleEditor->Create( RuleEditorDlg::IDD, this);
		m_dlgRuleEditor->ShowWindow( SW_SHOWNORMAL);
	}

	m_dlgRuleEditor->SetActiveWindow();
}

void FileTransDlg::validatorGen()
{
	CFileDialog dlg( TRUE, 0, 0, 0,
		"Paradigms (*.xmp)|*.xmp|Parsed Paradigms (*.parsed)|*.parsed|All Files (*.*)|*.*||");
	if( dlg.DoModal() == IDOK)
	{
		CString fn = dlg.GetPathName();
		int pos = fn.Find( '.');
		CString defname = fn.Left( pos) + "_validator.xsl";
		CFileDialog sdlg( FALSE, ".xsl", defname, OFN_OVERWRITEPROMPT, 
			"XSLT Files (*.xsl;*.xslt)|*.xsl; *.xslt|All Files (*.*)|*.*||");

		if( sdlg.DoModal() == IDOK)
		{
			Validator::job( dlg.GetPathName(), sdlg.GetPathName());
		}
	}
}

void FileTransDlg::selFile()
{
	CFileDialog dlg( TRUE, "xme", 0, OFN_ALLOWMULTISELECT|OFN_EXPLORER,
		"XME Files (*.xme;*.xml)|*.xme; *.xml|All Files (*.*)|*.*||");
	if( dlg.DoModal() == IDOK)
	{
		//m_lstFiles.addFile( dlg.GetFileName(), dlg.GetPathName());
		POSITION pos = dlg.GetStartPosition();
		while( pos)
		{
			CString path = dlg.GetNextPathName( pos);
			CFileFind ff;
			if(ff.FindFile(path))
			{
				ff.FindNextFile();
				m_lstFiles.addFile( ff.GetFileName(), path);
			}
		}
	}

}

void FileTransDlg::selDir()
{
	CString d = FileTransDlg::getDirectory();
	if( !d.IsEmpty())
		loadDir( d);
}

void FileTransDlg::loadDir( CString pDir)
{
	CFileFind finder;
	
	BOOL bWorking = finder.FindFile( pDir + "\\*.xme");
	while (bWorking)
	{
		bWorking = finder.FindNextFile();
		m_lstFiles.addFile( finder.GetFileName(), finder.GetFilePath());
	}
}


void FileTransDlg::process( const std::vector< std::string>& pToRun)
{
	std::vector< std::string> scripts = m_lstScript.getAllFiles();
	if( scripts.size() == 0 || scripts[0].empty()) { appendLn( "Invalid or no entries in script list!"); return; }
	bool multi = scripts.size() > 1;
	CString xsltScript, f_In, f_Out, f_OrigOut;

	appendLn( "Processing started on " + CTime::GetCurrentTime().Format("%b %d, %H:%M:%S"));

	std::vector<std::string> ok;
	std::vector<std::string> fail;
	for( unsigned int i = 0; i < pToRun.size(); ++i)
	{
		CString err;
		f_Out = f_In = pToRun[i].c_str();
		
		// transform a 'file.xme' to 'file_out.xme' in single case
		//                        to 'file_out01.xme' multiple case
		int dpos = f_Out.ReverseFind('.');
		if( dpos == -1) f_Out += FileTransDlg::m_strAppendStr;
		else f_Out.Insert( dpos, FileTransDlg::m_strAppendStr + (multi?"01":""));

		// change the output directory if specified
		if( directoryExists( FileTransDlg::m_strOutputDirStr))    // status fetched succesfully
		{
			dpos = f_Out.ReverseFind('\\');
			if( dpos == -1) // not found '\\'
			{
				f_Out.Insert( 0, '\\');
				f_Out.Insert( 0, FileTransDlg::m_strOutputDirStr);
			}
			else
			{
				f_Out = FileTransDlg::m_strOutputDirStr + '\\' + f_Out.Right( f_Out.GetLength() - dpos - 1);
			}
		}

		xsltScript = scripts[0].c_str();
		
		// do the 1st step separately
		apply( xsltScript, f_In, f_Out, err);

		// analyze error
		if( !err.IsEmpty())
		{
			fail.push_back( pToRun[i]);

			appendLn( f_In + (multi?" step 1 in":"") + " transformation failed: " + err);
		}
		else
		{
			ok.push_back( (LPCTSTR) f_Out);

			appendLn( f_In + (multi?" step 1 in":"") + " transformation OK.");
		}

		if( multi)
		{
			bool any_error = false;
			dpos = f_Out.ReverseFind('.');
			if( dpos != -1 && dpos >= 2) f_OrigOut = f_Out.Left( dpos-2); // "01" was already there
			else f_OrigOut = f_Out;

			// do the remaining steps
			for( unsigned int j = 1; err.IsEmpty() && j < scripts.size(); ++j)
			{
				err.Empty();
				CString j_str; 
				if( j+1 != scripts.size()) // the intermediate files look like: a_out01.xme
					j_str.Format( "%.2d", j+1);

				f_In = f_Out;
				f_Out = f_OrigOut + j_str + ".xme";
				xsltScript = scripts[j].c_str();

				// invoke step i
				apply( xsltScript, f_In, f_Out, err);
				
				j_str.Format( "%d", j+1);
				if( !err.IsEmpty())
				{
					fail.push_back( pToRun[i]); // the original file is marked
					any_error = true;

					appendLn( f_In + " step " + j_str + " in" + " transformation failed: " + err);
				}
				else
				{
					ok.push_back( (LPCTSTR) f_Out);

					appendLn( f_In + " step " + j_str + " in" + " transformation OK.");
				}
			}

			appendLn( CString( pToRun[i].c_str()) + " succesfully transformed to " + f_Out);
			appendLn( "");
		}

	}

	// mark the failed file list with 'failed'
	m_lstFiles.mark( fail);

	appendLn( CString( '=', 80));
	for( unsigned int i = 0; i < ok.size(); ++i)
	{
		if( i == 0) appendLn( "Successful cases:");
		appendLn( ok[i].c_str());
	}
	appendLn( CString( '-', 160));
	for( unsigned int i = 0; i < fail.size(); ++i)
	{
		if( i == 0) appendLn( "Failed cases:");
		appendLn( fail[i].c_str());
	}
}

void FileTransDlg::processSel()
{
	process( m_lstFiles.getSelFiles());
}

void FileTransDlg::processAll()
{
	process( m_lstFiles.getAllFiles());
}

void FileTransDlg::selScript()
{
	CFileDialog dlg( TRUE, "xsl", 0, OFN_ALLOWMULTISELECT|OFN_EXPLORER,
		"XSLT Files (*.xsl;*.xslt)|*.xsl; *.xslt|All Files (*.*)|*.*||");
	if( dlg.DoModal() == IDOK)
	{
		//m_lstScript.addFile( dlg.GetFileName(), dlg.GetPathName());
		POSITION pos = dlg.GetStartPosition();
		while( pos)
		{
			CString path = dlg.GetNextPathName( pos);
			CFileFind ff;
			if(ff.FindFile(path))
			{
				ff.FindNextFile();
				m_lstScript.addFile( ff.GetFileName(), path);
			}
		}
	}
}

void FileTransDlg::selScriptDir()
{
	CString d = FileTransDlg::getDirectory( "Load .xsl and .xslt files from directory");
	if( !d.IsEmpty())
		loadScriptDir( d);
}

void FileTransDlg::loadScriptDir( CString pDir)
{
	CFileFind finder;
	
	BOOL bWorking = finder.FindFile( pDir + "\\*.xsl");
	while (bWorking)
	{
		bWorking = finder.FindNextFile();
		m_lstScript.addFile( finder.GetFileName(), finder.GetFilePath());
	}

	bWorking = finder.FindFile( pDir + "\\*.xslt");
	while (bWorking)
	{
		bWorking = finder.FindNextFile();
		m_lstScript.addFile( finder.GetFileName(), finder.GetFilePath());
	}
}

void FileTransDlg::apply( CString pScrF, CString pInF, CString pOutF, CString& f4)
{
	CXslt::doNativeXslt( pScrF, pInF, pOutF, f4);
}

void FileTransDlg::loadMyOptions( CString& pStrVal1, CString& pStrVal2, CString& pStrVal3, CString& pStrVal4)
{
	CWinApp* pApp = AfxGetApp();

	pStrVal1 = pApp->GetProfileString( m_strSection, m_strDirStringItem);
	pStrVal2 = pApp->GetProfileString( m_strSection, m_strScrStringItem);
	pStrVal3 = pApp->GetProfileString( m_strSection, m_strAppendStringItem);
	pStrVal4 = pApp->GetProfileString( m_strSection, m_strOutputDirStringItem);
}

void FileTransDlg::saveMyOptions( const CString& pStrVal1, const CString& pStrVal2, const CString& pStrVal3, const CString& pStrVal4)
{
	CWinApp* pApp = AfxGetApp();

	pApp->WriteProfileString( m_strSection, m_strDirStringItem, pStrVal1);
	pApp->WriteProfileString( m_strSection, m_strScrStringItem, pStrVal2);
	pApp->WriteProfileString( m_strSection, m_strAppendStringItem, pStrVal3);
	pApp->WriteProfileString( m_strSection, m_strOutputDirStringItem, pStrVal4);
}

CString FileTransDlg::getDirectory( const CString& text)
{
	BROWSEINFO bi;
	TCHAR szDir[MAX_PATH];
	CString Dir = "";
	LPITEMIDLIST pidl;
	LPMALLOC pMalloc;	
	OleInitialize(NULL);
	if (SUCCEEDED(SHGetMalloc(&pMalloc)))
	{
		ZeroMemory(&bi,sizeof(bi));
		bi.hwndOwner = NULL;
		bi.pszDisplayName = 0;
		bi.lpszTitle = text;
		bi.pidlRoot = 0;
		bi.ulFlags = BIF_BROWSEINCLUDEFILES | BIF_RETURNONLYFSDIRS | BIF_STATUSTEXT | BIF_EDITBOX | BIF_VALIDATE ;
		bi.lpfn = NULL;
		//Displays a dialog box that enables the user to select a shell folder
		pidl = SHBrowseForFolder(&bi) ;
		if (pidl)
		{
			// Converts an item identifier list to a file system path
			if (!SHGetPathFromIDList(pidl,szDir))
			{
				pMalloc->Free(pidl) ;
				pMalloc->Release() ;
			}
			pMalloc->Free(pidl);
			pMalloc->Release();
		}
		else
		{	// Selected 'Not to save'
			return "";
		}
		Dir = szDir;
		//Dir += "\\";
	}
	// end of getting directory info 
	return Dir;
}

void FileTransDlg::closeDlgRuleEditor( int nRes)
{
	if( m_dlgRuleEditor)
	{
		if( m_dlgRuleEditor->GetSafeHwnd())
		{
			m_dlgRuleEditor->EndDialog( nRes);
			m_dlgRuleEditor->DestroyWindow();
		}
		delete m_dlgRuleEditor;
		m_dlgRuleEditor = 0;
	}
}

void FileTransDlg::OnOK()
{
	//IDOK is used for other purposes
	//closeDlgRuleEditor( IDOK);
}

void FileTransDlg::OnCancel()
{
	if( AfxMessageBox( "Do you really want to exit?", MB_YESNOCANCEL) == IDYES)
	{
		closeDlgRuleEditor( IDCANCEL);

		EndDialog( IDCANCEL);
		DestroyWindow();
	}
}

void FileTransDlg::appendLn( CString t)
{
	appendLog( t);
	appendLog( "\r\n");
}

void FileTransDlg::appendLog( CString t)
{
	CString old;
	m_log.GetWindowText( old);

	old.Append( t);

	m_log.SetWindowText( old);

	m_log.LineScroll( m_log.GetLineCount());
}

void FileTransDlg::clearLog()
{
	m_log.SetWindowText("");
}

bool FileTransDlg::directoryExists( const CString& dir)
{
	bool res = false;
	CFileStatus stat;
	if( !dir.IsEmpty()                   // not-empty string
		&& CFile::GetStatus( dir, stat)) // status fetched succesfully
	{
		if( (stat.m_attribute & CFile::directory) == CFile::directory // it is a directory
			&& (stat.m_attribute & CFile::readOnly)  == 0) // not read only
		{
			res = true;
		}
	}

	return res;
}

void FileTransDlg::OnBnClickedButtonclear()
{
	clearLog();
}


void FileTransDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		AboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

void FileTransDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

BOOL FileTransDlg::OnCommand(WPARAM wParam, LPARAM lParam)
{
	switch( wParam) {
		case IDOK: onReturn();                                    break; 
		case ID_SCRIPTS_ADD: selScript();                         break;
		case ID_SCRIPTS_ADDDIRECTORY: selScriptDir();             break;
		case ID_SCRIPTS_REMOVEALL: m_lstScript.removeAll();       break;
		case ID_SCRIPTS_REMOVESELECTED: m_lstScript.removeSel();  break;
		case ID_FILES_ADDFILE: selFile();                         break;
		case ID_FILES_ADDDIRECTORY: selDir();                     break;
		case ID_FILES_REMOVEALL: m_lstFiles.removeAll();          break;
		case ID_FILES_REMOVESELECTED: m_lstFiles.removeSel();     break;
		case ID_RULES_EDITRULES: ruleEditor();                    break;
		case ID_RULES_VALIDATE: validatorGen();                   break;
		case ID_PROCESSING_PROCESSALL: processAll();              break;
		case ID_PROCESSING_PROCESSSELECTED: processSel();         break;
		case ID_MISC_OPTIONS: options();                          break;
		case ID_MISC_CLEARLOG: clearLog();                        break;
	};

	return CDialog::OnCommand(wParam, lParam);
}

void FileTransDlg::onReturn()
{
	CWnd* child = this->GetFocus();
	if( !child) return;
	if( child == GetDlgItem(IDC_LISTSCRIPT))
	{ ; } // do nothing
	else if( child == GetDlgItem(IDC_LISTFILES))
		processSel();
}

void FileTransDlg::OnLvnKeydownListscript(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLVKEYDOWN pLVKeyDow = reinterpret_cast<LPNMLVKEYDOWN>(pNMHDR);
	NMLVKEYDOWN &s = *pLVKeyDow;

	bool cntrl = GetKeyState( VK_CONTROL) < 0;
	bool shft  = GetKeyState( VK_SHIFT) < 0;
	bool alt   = GetKeyState( VK_MENU) < 0; // alt key

	if( s.wVKey == VK_APPS) m_lstScript.showPopupMenu();
	if( s.wVKey == VK_F3 || s.wVKey == VK_INSERT && !cntrl) // F3, INS - Add Script
		SendMessage( WM_COMMAND, ID_SCRIPTS_ADD, 0);

	if( s.wVKey == VK_F4 && !alt || s.wVKey == VK_INSERT && cntrl) // F4, CTRL INS - Add Script Dir (but not ALT+F4)
		SendMessage( WM_COMMAND, ID_SCRIPTS_ADDDIRECTORY, 0);

	if( s.wVKey == VK_DELETE && !cntrl)
		SendMessage( WM_COMMAND, ID_SCRIPTS_REMOVESELECTED, 0);  // DEL - Remove Sel
	if( s.wVKey == VK_DELETE && cntrl)
		SendMessage( WM_COMMAND, ID_SCRIPTS_REMOVEALL, 0);       // CTRL DEL - Remove All
	

	if(( s.wVKey == IDOK || s.wVKey == VK_RETURN || s.wVKey == VK_F5) && !cntrl) // F5 - Run Sel
		SendMessage( WM_COMMAND, ID_PROCESSING_PROCESSSELECTED, 0);
	if(( s.wVKey == IDOK || s.wVKey == VK_RETURN || s.wVKey == VK_F5) && cntrl) // CTRL F5 - Run All
		SendMessage( WM_COMMAND, ID_PROCESSING_PROCESSALL, 0);


	*pResult = 0;
}

void FileTransDlg::OnLvnKeydownListfiles(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLVKEYDOWN pLVKeyDow = reinterpret_cast<LPNMLVKEYDOWN>(pNMHDR);
	NMLVKEYDOWN &s = *pLVKeyDow;

	bool cntrl = GetKeyState( VK_CONTROL) < 0;
	bool shft =  GetKeyState( VK_SHIFT) < 0;
	if( s.wVKey == VK_APPS) m_lstFiles.showPopupMenu();
	
	if( s.wVKey == VK_F6 || s.wVKey == VK_INSERT && !cntrl) // F6, INS - Add File
		SendMessage( WM_COMMAND, ID_FILES_ADDFILE, 0);

	if( s.wVKey == VK_F7 || s.wVKey == VK_INSERT && cntrl) // F7, CTRL INS - Add Dir
		SendMessage( WM_COMMAND, ID_FILES_ADDDIRECTORY, 0);

	if( s.wVKey == VK_DELETE && !cntrl)                    // DEL - Remove Sel
		SendMessage( WM_COMMAND, ID_FILES_REMOVESELECTED, 0);
	if( s.wVKey == VK_DELETE && cntrl)                     // CTRL DEL - Remove All
		SendMessage( WM_COMMAND, ID_FILES_REMOVEALL, 0);

	if(( s.wVKey == IDOK || s.wVKey == VK_RETURN || s.wVKey == VK_F5) && !cntrl) // F5 - Run Sel
		SendMessage( WM_COMMAND, ID_PROCESSING_PROCESSSELECTED, 0);
	if(( s.wVKey == IDOK || s.wVKey == VK_RETURN || s.wVKey == VK_F5) && cntrl) // CTRL F5 - Run All
		SendMessage( WM_COMMAND, ID_PROCESSING_PROCESSALL, 0);

	*pResult = 0;
}
